# net_put – Copy a file from Ansible Controller to a network device

New in version 2.6.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Status

## Synopsis

- This module provides functionality to copy file from Ansible controller to network devices.

## Requirements

The below requirements are needed on the host that executes this module.

- scp

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
dest - | Default: ["Filename from src and at default directory of user shell on network_os."] | Specifies the destination file. The path to destination file can either be the full path or relative path as supported by network_os.

mode
-
added in 2.7

Choices:
- binary ←
- text

Set the file transfer mode. If mode is set to text then src file will go through Jinja2 template engine to replace any vars if present in the src file. If mode is set to binary then file will be copied as it is to destination device.

protocol
-

Choices:
- scp ←
- sftp

Protocol used to transfer file.

src - / required |  | Specifies the source file. The path to the source file can either be the full path on the Ansible control host or a relative path from the playbook or role root directory.

## Notes

Note

- Some devices need specific configurations to be enabled before scp can work These configuration should be pre-configured before using this module e.g ios - `ip scp server enable`.
- User privilege to do scp on network device should be pre-configured e.g. ios - need user privilege 15 by default for allowing scp.
- Default destination of source file.
- This module is supported on `ansible_network_os` network platforms. See the Network Platform Options for details.

## Examples

    - name: copy file from ansible controller to a network device
      net_put:
        src: running_cfg_ios1.txt

    - name: copy file at root dir of flash in slot 3 of sw1(ios)
      net_put:
        src: running_cfg_sw1.txt
        protocol: sftp
        dest : flash3:/running_cfg_sw1.txt

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Network Team. [network]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Deepak Agrawal (@dagrawal)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.